#include "testApp.h"


int adc[3000];
int i;
bool flip;
ofImage uri;

int reds[]={72,177,51,113,210,186};
int greens[]={159,34,54,165,173,64};
int blues[]={159,36,41,56,20,40};

int red, green, blue;

//--------------------------------------------------------------
void testApp::setup(){	 
	for(int j=0;j<ofGetWidth();j++){
		adc[j]=0;
	}
	i=0;
	flip =false;
	
	ofSetVerticalSync(true);
	
	bSendSerialMessage = false;
	ofBackground(255,255,255);	
	
	
	serial.enumerateDevices();
	
	
	//----------------------------------- note:
	// < this should be set
	// to whatever com port
	// your serial device is
	// connected to.
	// (ie, COM4 on a pc, /dev/tty.... on linux, /dev/tty... on a mac)
	// arduino users check in arduino app....
	
	//serial.setup("COM4");  						  // windows example
	serial.setup("/dev/tty.usbserial-FTEZU8PM",9600); // mac osx example
	//serial.setup("/dev/ttyUSB0", 9600);			  //linux example
	
	//----------------------------------- 
	font.loadFont("DIN.otf",64);
	nTimesRead = 0;
	nBytesRead = 0;
	readTime = 0;
	memset(bytesReadString, 0, 4);
	
	ofSetColor(ofRandom(0,125),ofRandom(0,125),ofRandom(0,125));
}

//--------------------------------------------------------------
void testApp::update(){
	
	// (1) write the letter "a" to serial:
	//serial.writeByte('a');
	
	// (2) read
	// now we try to read 3 bytes
	// since we might not get them all the time 3 - but sometimes 0, 6, or something else,
	// we will try to read three bytes, as much as we can
	// otherwise, we may have a "lag" if we don't read fast enough
	// or just read three every time. now, we will be sure to 
	// read as much as we can in groups of three...
	
	nTimesRead = 0;
	nBytesRead = 0;
	int nRead  = 0;  // a temp variable to keep count per read
	
	unsigned char bytesReturned[3];
	
	memset(bytesReadString, 0, 4);
	memset(bytesReturned, 0, 3);
	
	
	while(serial.available()){
		nRead = serial.readBytes( bytesReturned, 3);
		nTimesRead++;	
		nBytesRead = nRead;
	};
	
	memcpy(bytesReadString, bytesReturned, 3);
	
	bSendSerialMessage = false;
	readTime = ofGetElapsedTimef();
	uri.loadImage("geller.jpeg");
	
	int generator = (int)round(ofRandom(0,5));
	
	red = reds[generator];
	green = greens[generator];
	blue = blues[generator];
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	//printf("\n%d",int(*bytesReadString));
	/*//if(int(*bytesReadString) == 1 || int(*bytesReadString) == 2 || int(*bytesReadString) == 3 || int(*bytesReadString == 4)) printf("\n\nSYNC!");
	if(0);
	else{
		if(flip){
			adc[i] = int(*bytesReadString);

			ofSetColor(0,0,0);
			ofFill();
			
			for(int j=0;j<1024;j++){
				ofCircle(j, 384+(2*adc[j]), 1);
			}
			
			i<1024 ? i++ : i=0;
			flip=false;
			//printf("\n\n>>>%d: %d",i,adc[i]);
		}
		else{
			adc[i] = adc[i]+ int(*bytesReadString)*512;
			flip=true;
			
		}
		
	}*/
	ofSetColor(255,0,0);
	
	if(int(*bytesReadString) > 60){
		adc[i] = int(*bytesReadString);
		ofFill();
		for(int j=0;j<ofGetWidth();j++){
			ofCircle(j, 10*adc[j]-400, 2);
		}		
		
		if(i<ofGetWidth()) i++;
		else{
			i=0;

			for(int j=0;j<ofGetWidth();j++){
				adc[j]=0;
			}
			
		}
	}
	else{
		for(int j=0;j<ofGetWidth();j++){
			ofCircle(j, 10*adc[j]-400, 2);
		}	
	}
	uri.draw(ofGetWidth()/3, 500);
	
	ofSetColor(red,green, blue);
	ofCircle(716, 662, 10);
	ofCircle(768, 662, 10);
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	bSendSerialMessage = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){
	
}

